"use strict";
exports.__esModule = true;
// import 'rxjs/add/operator/do';
var rx_http_request_1 = require("@akanass/rx-http-request");
var isString = function (val) { return typeof val === 'string' || ((!!val && typeof val === 'object') && Object.prototype.toString.call(val) === '[object String]'); };
var isObject = function (val) { return typeof val === 'object'; };
var BChain = /** @class */ (function () {
    function BChain(auth, url) {
        if (url === void 0) { url = 'http://localhost:2890/'; }
        var _this = this;
        this.auth = auth;
        this.url = url;
        this.commands = {
            //general
            createMultiSig: ['nrequired', 'keys'],
            getInfo: [],
            getRuntimeParams: [],
            setRunTimeparam: ['param', 'value'],
            getBlockchainParams: [],
            help: [],
            stop: [],
            validateAddress: ['address'],
            createKeyPairs: [],
            //wallet addresses
            addMultiSigAddress: ['nrequired', 'keys'],
            dumpPrivKey: ['address'],
            getAddresses: [{ 'verbose': false }],
            getNewAddress: [],
            importAddress: ['address', { 'label': '' }, { 'rescan': true }],
            listAddresses: [],
            //permissions
            grant: ['addresses', 'permissions',
                { 'native-amount': null }, { 'start-block': null }, { 'end-block': null }, { 'comment': null }, { 'comment-to': null }],
            grantFrom: ['from', 'to', 'permissions',
                { 'native-amount': null }, { 'start-block': null }, { 'end-block': null }, { 'comment': null }, { 'comment-to': null }],
            grantWithData: ['addresses', 'permissions', 'data', { 'native-amount': null }, { 'start-block': null }, { 'end-block': null }],
            grantWithMetadata: ['addresses', 'permissions', 'data', { 'native-amount': null }, { 'start-block': null }, { 'end-block': null }],
            grantWithDatafrom: ['from', 'to', 'permissions', 'data', { 'native-amount': null }, { 'start-block': null }, { 'end-block': null }],
            grantWithMetadataFrom: ['from', 'to', 'permissions', 'data', { 'native-amount': null }, { 'start-block': null }, { 'end-block': null }],
            listPermissions: [{ 'permissions': 'all' }, { 'addresses': '*' }, { 'verbose': false }],
            revoke: ['addresses', 'permissions', { 'native-amount': 0 }, { 'comment': '' }, { 'comment-to': '' }],
            revokeFrom: ['from', 'to', 'permissions', { 'native-amount': 0 }, { 'comment': '' }, { 'comment-to': '' }],
            //assets
            issue: ['address', 'asset', 'qty', { 'units': 1 }, { 'native-amount': 0 }, { 'details': {} }],
            issueFrom: ['from', 'to', 'asset', 'qty', { 'units': 1 }, { 'native-amount': 0 }, { 'details': {} }],
            issueMore: ['address', 'asset', 'qty', { 'native-amount': 0 }, { 'details': {} }],
            issueMoreFrom: ['from', 'to', 'asset', 'qty', { 'native-amount': 0 }, { 'details': {} }],
            listAssets: [{ 'asset': '' }, { 'verbose': false }, { 'count': 10 }, { 'start': -10 }],
            //querying
            getAddressBalances: ['address', { 'minconf': 1 }, { 'includeLocked': false }],
            getAddressTransaction: ['address', 'txid', { 'verbose': false }],
            getMultiBalances: [{ 'addresses': '*' }, { 'assets': [] }, { 'minconf': 1 }, { 'includeWatchOnly': false }, { 'includeLocked': false }],
            getTotalBalances: [{ 'minconf': 1 }, { 'includeWatchOnly': false }, { 'includeLocked': false }],
            getWalletTransaction: ['txid', { 'includeWatchOnly': false }, { 'verbose': false }],
            listAddressTransactions: ['address', { 'count': 10 }, { 'skip': 0 }, { 'verbose': false }],
            listWalletTransactions: [{ 'count': 10 }, { 'skip': 0 }, { 'includeWatchOnly': false }, { 'verbose': false }],
            //querying subscribed assets
            getAsseTtransaction: ['asset', 'txid', { 'verbose': false }],
            listAssetTransactions: ['asset', { 'verbose': false }, { 'count': 10 }, { 'start': -10 }, { 'local-ordering': false }],
            //sending
            sendAssetFrom: ['from', 'to', 'asset', 'qty', { 'native-amount': 0 }, { 'comment': '' }, { 'comment-to': '' }],
            sendAsset: ['address', 'asset', 'qty', { 'native-amount': 0 }, { 'comment': '' }, { 'comment-to': '' }],
            sendAssetToAddress: ['address', 'asset', 'qty', { 'native-amount': 0 }, { 'comment': '' }, { 'comment-to': '' }],
            sendFrom: ['from', 'to', 'amount', { 'comment': '' }, { 'comment-to': '' }],
            sendFromAddress: ['from', 'to', 'amount', { 'comment': '' }, { 'comment-to': '' }],
            send: ['address', 'amount', { 'comment': '' }, { 'comment-to': '' }],
            sendToAddress: ['address', 'amount', { 'comment': '' }, { 'comment-to': '' }],
            sendwithData: ['address', 'amount', 'data'],
            sendWithMetadata: ['address', 'amount', 'data'],
            sendwithDataFrom: ['address', 'amount', 'data'],
            sendWithMetadataFrom: ['from', 'to', 'amount', 'data'],
            //atomic exchange
            appendRawExchange: ['hexstring', 'txid', 'vout', 'assets'],
            completeRawExchange: ['hexstring', 'txid', 'vout', 'assets', 'data'],
            createRawExchange: ['txid', 'vout', 'assets'],
            decodeRawExchange: ['hexstring', { 'verbose': false }],
            disableRawTransaction: ['hexstring'],
            prepareLockUnspent: ['assets', { 'lock': true }],
            prepareLockUnspentFrom: ['from', 'assets', { 'lock': true }],
            //stream management
            create: [{ 'type': 'stream' }, 'name', 'open', { 'details': {} }],
            createFrom: ['from', { 'type': 'stream' }, 'name', 'open', { 'details': {} }],
            listStreams: [{ 'stream': '*' }, { 'verbose': 'false' }, { 'count': undefined }, { 'start': undefined }],
            subscribe: ['stream', { 'rescan': true }],
            unsubscribe: ['stream'],
            //querying stream items
            getTxOutData: ['txid', 'vout'],
            listStreamKeyItems: ['stream', 'key', { 'verbose': 'false' }, { 'count': 10 }, { 'start': -10 }, { 'local-ordering': false }],
            listStreamKeys: ['stream', { 'key': '*' }, { 'verbose': 'false' }, { 'count': 10 }, { 'start': -10 }, { 'local-ordering': false }],
            listStreamItems: ['stream', { 'verbose': 'false' }, { 'count': 10 }, { 'start': -10 }, { 'local-ordering': false }],
            listStreamPublisherItems: ['stream', 'address', { 'verbose': 'false' }, { 'count': 10 }, { 'start': -10 }, { 'local-ordering': false }],
            listStreamPublishers: ['stream', { 'address': '*' }, { 'verbose': 'false' }, { 'count': 10 }, { 'start': -10 }, { 'local-ordering': false }],
            getStreamItem: ['stream', 'txid', { 'verbose': 'false' }],
            //publishing stream items
            publish: ['stream', 'key', 'data'],
            publishFrom: ['from', 'stream', 'key', 'data'],
            //unspent
            combineUnspent: [{ 'addresses': '*' }, { 'minconf': 1 }, { 'maxcombines': 1 }, { 'mininputs': 10 }, { 'maxinputs': 100 }, { 'maxtime': 30 }],
            listLockUnspent: [],
            listUnspent: [{ 'minconf': 1 }, { 'maxconf': 999999 }, { 'receivers': [] }],
            lockUnspent: ['unlock', { 'outputs': [] }],
            //raw tx
            appendRawChange: ['hexstring', 'address', { 'native-fee': undefined }],
            appendRawWata: ['tx', 'data'],
            appendRawMetadata: ['tx', 'data'],
            createRawTransaction: ['inputs', 'amounts'],
            createRawSendFrom: ['from', 'to'],
            decodeRawTransaction: ['hexstring'],
            sendRawTransaction: ['hexstring'],
            signRawTransaction: ['hexstring', { 'parents': null }, { 'privatekeys': null }, { 'sighashtype': null }],
            searchRawTransactions: ['address', { 'verbose': 1 }, { 'skip': 0 }, { 'count': 100 }],
            //p2p
            addNode: ['ip', 'command'],
            getAddedNodeinfo: ['verbose'],
            getNetworkInfo: [],
            getPeerInfo: [],
            ping: [],
            //messaging
            signMessage: ['address', 'message'],
            verifyMessage: ['address', 'signature', 'message'],
            //blockchain query
            getBlock: ['hash', { 'format': true }],
            getBlockHash: ['height'],
            getRawTransaction: ['txid', { 'verbose': 0 }],
            getTxOut: ['txid', 'vout', { 'unconfirmed': false }],
            //advanced node control
            clearMemPool: [],
            pause: ['tasks'],
            resume: ['tasks'],
            setLastBlock: ['hash'],
            //mining
            getMiningInfo: [],
            //advanced wallet control
            backupWallet: ['filename'],
            dumpWallet: ['filename'],
            encryptWallet: ['passphrase'],
            getWalletInfo: [],
            importPrivKey: ['privkey', { 'label': '' }, { 'rescan': true }],
            importWallet: ['filename'],
            walletLock: [],
            walletPassphrase: ['passphrase', 'timeout'],
            walletPassphraseChange: ['old-passphrase', 'new-passphrase']
        };
        this.undefinedFunctions = Object.keys(this.commands).map(function (method) {
            if (_this[method])
                return;
            var commands = _this.commands[method];
            _this[method] = function (args) { return _this.call(method.toLowerCase(), args); };
            return _this.getFunctionString(method, commands);
        })
            .filter(function (item) { return item !== undefined; })
            .sort(function (a, b) { return a.localeCompare(b); });
    }
    BChain.prototype.parseParams = function (method, args) {
        var commandParams = this.commands[method];
        return commandParams.map(function (arg) {
            if (isString(arg))
                return args[arg];
            if (isObject(arg)) {
                var key = Object.keys(arg)[0];
                var value = args[key];
                return (typeof value !== 'undefined') ? value : arg[key]; // default
            }
        });
    };
    BChain.prototype.getFunctionString = function (method, params) {
        var defaultToStr = function (d) { return isString(d) ? "'" + d + "'" : (Array.isArray(d) ? '[]' : (isObject(d) ? '{}' : d)); };
        var getDefaultStr = function (param) { return '=' + defaultToStr(param[Object.keys(param)[0]]); };
        var fixStr = function (param, addDefault) {
            if (addDefault === void 0) { addDefault = false; }
            return param.toString().replace(/-/g, '_');
        };
        var toStr = function (param, addDefault) {
            if (addDefault === void 0) { addDefault = false; }
            return (typeof param === 'string') ?
                fixStr(param) : fixStr(Object.keys(param)[0]) + (addDefault ? getDefaultStr(param) : '');
        };
        var toParams = function (str, v, i, arr) { return str + toStr(v, true) + (i === (arr.length - 1) ? '' : ', '); }; // TODO: add default
        var toArray = function (str, v, i, arr) { return str + toStr(v) + (i === (arr.length - 1) ? '' : ', '); };
        return method + '(' + params.reduce(toParams, '') + '): Observable<Object> { return this.call(\'' + method.toLowerCase()
            + '\', [' + params.reduce(toArray, '') + ']);}';
    };
    BChain.prototype.call = function (method, args) {
        if (args === void 0) { args = null; }
        // console.log("getIfno::: ", arguments.callee.toString() );
        var params = args ? Array.isArray(args) ? args : this.parseParams(method, args) : [];
        var payload = { method: method, params: params, id: 1, jsonrpc: '2.0' };
        return rx_http_request_1.RxHR.post(this.url, {
            json: true,
            body: payload,
            auth: this.auth
            // auth: 'multichainrpc' + ":" + '6FvcobcXbS2UPXEmkVBof32B15fNMR9UPhVtUzvq6CCP',
        })
            .map(function (data) {
            if (data.response.statusCode !== 200)
                throw new Error(data.response.statusCode + " " + data.response.statusMessage);
            return data.response.body;
        });
    };
    /**
    *	Below is the set of auto-generated functions.
    */
    BChain.prototype.addMultiSigAddress = function (nrequired, keys) { return this.call('addmultisigaddress', [nrequired, keys]); };
    BChain.prototype.addNode = function (ip, command) { return this.call('addnode', [ip, command]); };
    BChain.prototype.appendRawChange = function (hexstring, address, native_fee) {
        if (native_fee === void 0) { native_fee = undefined; }
        return this.call('appendrawchange', [hexstring, address, native_fee]);
    };
    BChain.prototype.appendRawExchange = function (hexstring, txid, vout, assets) { return this.call('appendrawexchange', [hexstring, txid, vout, assets]); };
    BChain.prototype.appendRawMetadata = function (tx, data) { return this.call('appendrawmetadata', [tx, data]); };
    BChain.prototype.appendRawWata = function (tx, data) { return this.call('appendrawwata', [tx, data]); };
    BChain.prototype.backupWallet = function (filename) { return this.call('backupwallet', [filename]); };
    BChain.prototype.clearMemPool = function () { return this.call('clearmempool', []); };
    BChain.prototype.combineUnspent = function (addresses, minconf, maxcombines, mininputs, maxinputs, maxtime) {
        if (addresses === void 0) { addresses = '*'; }
        if (minconf === void 0) { minconf = 1; }
        if (maxcombines === void 0) { maxcombines = 1; }
        if (mininputs === void 0) { mininputs = 10; }
        if (maxinputs === void 0) { maxinputs = 100; }
        if (maxtime === void 0) { maxtime = 30; }
        return this.call('combineunspent', [addresses, minconf, maxcombines, mininputs, maxinputs, maxtime]);
    };
    BChain.prototype.completeRawExchange = function (hexstring, txid, vout, assets, data) { return this.call('completerawexchange', [hexstring, txid, vout, assets, data]); };
    BChain.prototype.create = function (type, name, open, details) {
        if (type === void 0) { type = 'stream'; }
        if (details === void 0) { details = {}; }
        return this.call('create', [type, name, open, details]);
    };
    BChain.prototype.createFrom = function (from, type, name, open, details) {
        if (type === void 0) { type = 'stream'; }
        if (details === void 0) { details = {}; }
        return this.call('createfrom', [from, type, name, open, details]);
    };
    BChain.prototype.createKeyPairs = function () { return this.call('createkeypairs', []); };
    BChain.prototype.createMultiSig = function (nrequired, keys) { return this.call('createmultisig', [nrequired, keys]); };
    BChain.prototype.createRawExchange = function (txid, vout, assets) { return this.call('createrawexchange', [txid, vout, assets]); };
    BChain.prototype.createRawSendFrom = function (from, to) { return this.call('createrawsendfrom', [from, to]); };
    BChain.prototype.createRawTransaction = function (inputs, amounts) { return this.call('createrawtransaction', [inputs, amounts]); };
    BChain.prototype.decodeRawExchange = function (hexstring, verbose) {
        if (verbose === void 0) { verbose = false; }
        return this.call('decoderawexchange', [hexstring, verbose]);
    };
    BChain.prototype.decodeRawTransaction = function (hexstring) { return this.call('decoderawtransaction', [hexstring]); };
    BChain.prototype.disableRawTransaction = function (hexstring) { return this.call('disablerawtransaction', [hexstring]); };
    BChain.prototype.dumpPrivKey = function (address) { return this.call('dumpprivkey', [address]); };
    BChain.prototype.dumpWallet = function (filename) { return this.call('dumpwallet', [filename]); };
    BChain.prototype.encryptWallet = function (passphrase) { return this.call('encryptwallet', [passphrase]); };
    BChain.prototype.getAddedNodeinfo = function (verbose) { return this.call('getaddednodeinfo', [verbose]); };
    BChain.prototype.getAddressBalances = function (address, minconf, includeLocked) {
        if (minconf === void 0) { minconf = 1; }
        if (includeLocked === void 0) { includeLocked = false; }
        return this.call('getaddressbalances', [address, minconf, includeLocked]);
    };
    BChain.prototype.getAddresses = function (verbose) {
        if (verbose === void 0) { verbose = false; }
        return this.call('getaddresses', [verbose]);
    };
    BChain.prototype.getAddressTransaction = function (address, txid, verbose) {
        if (verbose === void 0) { verbose = false; }
        return this.call('getaddresstransaction', [address, txid, verbose]);
    };
    BChain.prototype.getAsseTtransaction = function (asset, txid, verbose) {
        if (verbose === void 0) { verbose = false; }
        return this.call('getassettransaction', [asset, txid, verbose]);
    };
    BChain.prototype.getBlock = function (hash, format) {
        if (format === void 0) { format = true; }
        return this.call('getblock', [hash, format]);
    };
    BChain.prototype.getBlockchainParams = function () { return this.call('getblockchainparams', []); };
    BChain.prototype.getBlockHash = function (height) { return this.call('getblockhash', [height]); };
    BChain.prototype.getInfo = function () { return this.call('getinfo', []); };
    BChain.prototype.getMiningInfo = function () { return this.call('getmininginfo', []); };
    BChain.prototype.getMultiBalances = function (addresses, assets, minconf, includeWatchOnly, includeLocked) {
        if (addresses === void 0) { addresses = '*'; }
        if (assets === void 0) { assets = []; }
        if (minconf === void 0) { minconf = 1; }
        if (includeWatchOnly === void 0) { includeWatchOnly = false; }
        if (includeLocked === void 0) { includeLocked = false; }
        return this.call('getmultibalances', [addresses, assets, minconf, includeWatchOnly, includeLocked]);
    };
    BChain.prototype.getNetworkInfo = function () { return this.call('getnetworkinfo', []); };
    BChain.prototype.getNewAddress = function () { return this.call('getnewaddress', []); };
    BChain.prototype.getPeerInfo = function () { return this.call('getpeerinfo', []); };
    BChain.prototype.getRawTransaction = function (txid, verbose) {
        if (verbose === void 0) { verbose = 0; }
        return this.call('getrawtransaction', [txid, verbose]);
    };
    BChain.prototype.getRuntimeParams = function () { return this.call('getruntimeparams', []); };
    BChain.prototype.getStreamItem = function (stream, txid, verbose) {
        if (verbose === void 0) { verbose = 'false'; }
        return this.call('getstreamitem', [stream, txid, verbose]);
    };
    BChain.prototype.getTotalBalances = function (minconf, includeWatchOnly, includeLocked) {
        if (minconf === void 0) { minconf = 1; }
        if (includeWatchOnly === void 0) { includeWatchOnly = false; }
        if (includeLocked === void 0) { includeLocked = false; }
        return this.call('gettotalbalances', [minconf, includeWatchOnly, includeLocked]);
    };
    BChain.prototype.getTxOut = function (txid, vout, unconfirmed) {
        if (unconfirmed === void 0) { unconfirmed = false; }
        return this.call('gettxout', [txid, vout, unconfirmed]);
    };
    BChain.prototype.getTxOutData = function (txid, vout) { return this.call('gettxoutdata', [txid, vout]); };
    BChain.prototype.getWalletInfo = function () { return this.call('getwalletinfo', []); };
    BChain.prototype.getWalletTransaction = function (txid, includeWatchOnly, verbose) {
        if (includeWatchOnly === void 0) { includeWatchOnly = false; }
        if (verbose === void 0) { verbose = false; }
        return this.call('getwallettransaction', [txid, includeWatchOnly, verbose]);
    };
    BChain.prototype.grant = function (addresses, permissions, native_amount, start_block, end_block, comment, comment_to) {
        if (native_amount === void 0) { native_amount = {}; }
        if (start_block === void 0) { start_block = {}; }
        if (end_block === void 0) { end_block = {}; }
        if (comment === void 0) { comment = {}; }
        if (comment_to === void 0) { comment_to = {}; }
        return this.call('grant', [addresses, permissions, native_amount, start_block, end_block, comment, comment_to]);
    };
    BChain.prototype.grantFrom = function (from, to, permissions, native_amount, start_block, end_block, comment, comment_to) {
        if (native_amount === void 0) { native_amount = {}; }
        if (start_block === void 0) { start_block = {}; }
        if (end_block === void 0) { end_block = {}; }
        if (comment === void 0) { comment = {}; }
        if (comment_to === void 0) { comment_to = {}; }
        return this.call('grantfrom', [from, to, permissions, native_amount, start_block, end_block, comment, comment_to]);
    };
    BChain.prototype.grantWithData = function (addresses, permissions, data, native_amount, start_block, end_block) {
        if (native_amount === void 0) { native_amount = {}; }
        if (start_block === void 0) { start_block = {}; }
        if (end_block === void 0) { end_block = {}; }
        return this.call('grantwithdata', [addresses, permissions, data, native_amount, start_block, end_block]);
    };
    BChain.prototype.grantWithDatafrom = function (from, to, permissions, data, native_amount, start_block, end_block) {
        if (native_amount === void 0) { native_amount = {}; }
        if (start_block === void 0) { start_block = {}; }
        if (end_block === void 0) { end_block = {}; }
        return this.call('grantwithdatafrom', [from, to, permissions, data, native_amount, start_block, end_block]);
    };
    BChain.prototype.grantWithMetadata = function (addresses, permissions, data, native_amount, start_block, end_block) {
        if (native_amount === void 0) { native_amount = {}; }
        if (start_block === void 0) { start_block = {}; }
        if (end_block === void 0) { end_block = {}; }
        return this.call('grantwithmetadata', [addresses, permissions, data, native_amount, start_block, end_block]);
    };
    BChain.prototype.grantWithMetadataFrom = function (from, to, permissions, data, native_amount, start_block, end_block) {
        if (native_amount === void 0) { native_amount = {}; }
        if (start_block === void 0) { start_block = {}; }
        if (end_block === void 0) { end_block = {}; }
        return this.call('grantwithmetadatafrom', [from, to, permissions, data, native_amount, start_block, end_block]);
    };
    BChain.prototype.help = function () { return this.call('help', []); };
    BChain.prototype.importAddress = function (address, label, rescan) {
        if (label === void 0) { label = ''; }
        if (rescan === void 0) { rescan = true; }
        return this.call('importaddress', [address, label, rescan]);
    };
    BChain.prototype.importPrivKey = function (privkey, label, rescan) {
        if (label === void 0) { label = ''; }
        if (rescan === void 0) { rescan = true; }
        return this.call('importprivkey', [privkey, label, rescan]);
    };
    BChain.prototype.importWallet = function (filename) { return this.call('importwallet', [filename]); };
    BChain.prototype.issue = function (address, asset, qty, units, native_amount, details) {
        if (units === void 0) { units = 1; }
        if (native_amount === void 0) { native_amount = 0; }
        if (details === void 0) { details = {}; }
        return this.call('issue', [address, asset, qty, units, native_amount, details]);
    };
    BChain.prototype.issueFrom = function (from, to, asset, qty, units, native_amount, details) {
        if (units === void 0) { units = 1; }
        if (native_amount === void 0) { native_amount = 0; }
        if (details === void 0) { details = {}; }
        return this.call('issuefrom', [from, to, asset, qty, units, native_amount, details]);
    };
    BChain.prototype.issueMore = function (address, asset, qty, native_amount, details) {
        if (native_amount === void 0) { native_amount = 0; }
        if (details === void 0) { details = {}; }
        return this.call('issuemore', [address, asset, qty, native_amount, details]);
    };
    BChain.prototype.issueMoreFrom = function (from, to, asset, qty, native_amount, details) {
        if (native_amount === void 0) { native_amount = 0; }
        if (details === void 0) { details = {}; }
        return this.call('issuemorefrom', [from, to, asset, qty, native_amount, details]);
    };
    BChain.prototype.listAddresses = function () { return this.call('listaddresses', []); };
    BChain.prototype.listAddressTransactions = function (address, count, skip, verbose) {
        if (count === void 0) { count = 10; }
        if (skip === void 0) { skip = 0; }
        if (verbose === void 0) { verbose = false; }
        return this.call('listaddresstransactions', [address, count, skip, verbose]);
    };
    BChain.prototype.listAssets = function (asset, verbose, count, start) {
        if (asset === void 0) { asset = ''; }
        if (verbose === void 0) { verbose = false; }
        if (count === void 0) { count = 10; }
        if (start === void 0) { start = -10; }
        return this.call('listassets', [asset, verbose, count, start]);
    };
    BChain.prototype.listAssetTransactions = function (asset, verbose, count, start, local_ordering) {
        if (verbose === void 0) { verbose = false; }
        if (count === void 0) { count = 10; }
        if (start === void 0) { start = -10; }
        if (local_ordering === void 0) { local_ordering = false; }
        return this.call('listassettransactions', [asset, verbose, count, start, local_ordering]);
    };
    BChain.prototype.listLockUnspent = function () { return this.call('listlockunspent', []); };
    BChain.prototype.listPermissions = function (permissions, addresses, verbose) {
        if (permissions === void 0) { permissions = 'all'; }
        if (addresses === void 0) { addresses = '*'; }
        if (verbose === void 0) { verbose = false; }
        return this.call('listpermissions', [permissions, addresses, verbose]);
    };
    BChain.prototype.listStreamItems = function (stream, verbose, count, start, local_ordering) {
        if (verbose === void 0) { verbose = 'false'; }
        if (count === void 0) { count = 10; }
        if (start === void 0) { start = -10; }
        if (local_ordering === void 0) { local_ordering = false; }
        return this.call('liststreamitems', [stream, verbose, count, start, local_ordering]);
    };
    BChain.prototype.listStreamKeyItems = function (stream, key, verbose, count, start, local_ordering) {
        if (verbose === void 0) { verbose = 'false'; }
        if (count === void 0) { count = 10; }
        if (start === void 0) { start = -10; }
        if (local_ordering === void 0) { local_ordering = false; }
        return this.call('liststreamkeyitems', [stream, key, verbose, count, start, local_ordering]);
    };
    BChain.prototype.listStreamKeys = function (stream, key, verbose, count, start, local_ordering) {
        if (key === void 0) { key = '*'; }
        if (verbose === void 0) { verbose = 'false'; }
        if (count === void 0) { count = 10; }
        if (start === void 0) { start = -10; }
        if (local_ordering === void 0) { local_ordering = false; }
        return this.call('liststreamkeys', [stream, key, verbose, count, start, local_ordering]);
    };
    BChain.prototype.listStreamPublisherItems = function (stream, address, verbose, count, start, local_ordering) {
        if (verbose === void 0) { verbose = 'false'; }
        if (count === void 0) { count = 10; }
        if (start === void 0) { start = -10; }
        if (local_ordering === void 0) { local_ordering = false; }
        return this.call('liststreampublisheritems', [stream, address, verbose, count, start, local_ordering]);
    };
    BChain.prototype.listStreamPublishers = function (stream, address, verbose, count, start, local_ordering) {
        if (address === void 0) { address = '*'; }
        if (verbose === void 0) { verbose = 'false'; }
        if (count === void 0) { count = 10; }
        if (start === void 0) { start = -10; }
        if (local_ordering === void 0) { local_ordering = false; }
        return this.call('liststreampublishers', [stream, address, verbose, count, start, local_ordering]);
    };
    BChain.prototype.listStreams = function (stream, verbose, count, start) {
        if (stream === void 0) { stream = '*'; }
        if (verbose === void 0) { verbose = 'false'; }
        if (count === void 0) { count = undefined; }
        if (start === void 0) { start = undefined; }
        return this.call('liststreams', [stream, verbose, count, start]);
    };
    BChain.prototype.listUnspent = function (minconf, maxconf, receivers) {
        if (minconf === void 0) { minconf = 1; }
        if (maxconf === void 0) { maxconf = 999999; }
        if (receivers === void 0) { receivers = []; }
        return this.call('listunspent', [minconf, maxconf, receivers]);
    };
    BChain.prototype.listWalletTransactions = function (count, skip, includeWatchOnly, verbose) {
        if (count === void 0) { count = 10; }
        if (skip === void 0) { skip = 0; }
        if (includeWatchOnly === void 0) { includeWatchOnly = false; }
        if (verbose === void 0) { verbose = false; }
        return this.call('listwallettransactions', [count, skip, includeWatchOnly, verbose]);
    };
    BChain.prototype.lockUnspent = function (unlock, outputs) {
        if (outputs === void 0) { outputs = []; }
        return this.call('lockunspent', [unlock, outputs]);
    };
    BChain.prototype.pause = function (tasks) { return this.call('pause', [tasks]); };
    BChain.prototype.ping = function () { return this.call('ping', []); };
    BChain.prototype.prepareLockUnspent = function (assets, lock) {
        if (lock === void 0) { lock = true; }
        return this.call('preparelockunspent', [assets, lock]);
    };
    BChain.prototype.prepareLockUnspentFrom = function (from, assets, lock) {
        if (lock === void 0) { lock = true; }
        return this.call('preparelockunspentfrom', [from, assets, lock]);
    };
    BChain.prototype.publish = function (stream, key, data) { return this.call('publish', [stream, key, data]); };
    BChain.prototype.publishFrom = function (from, stream, key, data) { return this.call('publishfrom', [from, stream, key, data]); };
    BChain.prototype.resume = function (tasks) { return this.call('resume', [tasks]); };
    BChain.prototype.revoke = function (addresses, permissions, native_amount, comment, comment_to) {
        if (native_amount === void 0) { native_amount = 0; }
        if (comment === void 0) { comment = ''; }
        if (comment_to === void 0) { comment_to = ''; }
        return this.call('revoke', [addresses, permissions, native_amount, comment, comment_to]);
    };
    BChain.prototype.revokeFrom = function (from, to, permissions, native_amount, comment, comment_to) {
        if (native_amount === void 0) { native_amount = 0; }
        if (comment === void 0) { comment = ''; }
        if (comment_to === void 0) { comment_to = ''; }
        return this.call('revokefrom', [from, to, permissions, native_amount, comment, comment_to]);
    };
    BChain.prototype.searchRawTransactions = function (address, verbose, skip, count) {
        if (verbose === void 0) { verbose = 1; }
        if (skip === void 0) { skip = 0; }
        if (count === void 0) { count = 100; }
        return this.call('searchrawtransactions', [address, verbose, skip, count]);
    };
    BChain.prototype.send = function (address, amount, comment, comment_to) {
        if (comment === void 0) { comment = ''; }
        if (comment_to === void 0) { comment_to = ''; }
        return this.call('send', [address, amount, comment, comment_to]);
    };
    BChain.prototype.sendAsset = function (address, asset, qty, native_amount, comment, comment_to) {
        if (native_amount === void 0) { native_amount = 0; }
        if (comment === void 0) { comment = ''; }
        if (comment_to === void 0) { comment_to = ''; }
        return this.call('sendasset', [address, asset, qty, native_amount, comment, comment_to]);
    };
    BChain.prototype.sendAssetFrom = function (from, to, asset, qty, native_amount, comment, comment_to) {
        if (native_amount === void 0) { native_amount = 0; }
        if (comment === void 0) { comment = ''; }
        if (comment_to === void 0) { comment_to = ''; }
        return this.call('sendassetfrom', [from, to, asset, qty, native_amount, comment, comment_to]);
    };
    BChain.prototype.sendAssetToAddress = function (address, asset, qty, native_amount, comment, comment_to) {
        if (native_amount === void 0) { native_amount = 0; }
        if (comment === void 0) { comment = ''; }
        if (comment_to === void 0) { comment_to = ''; }
        return this.call('sendassettoaddress', [address, asset, qty, native_amount, comment, comment_to]);
    };
    BChain.prototype.sendFrom = function (from, to, amount, comment, comment_to) {
        if (comment === void 0) { comment = ''; }
        if (comment_to === void 0) { comment_to = ''; }
        return this.call('sendfrom', [from, to, amount, comment, comment_to]);
    };
    BChain.prototype.sendFromAddress = function (from, to, amount, comment, comment_to) {
        if (comment === void 0) { comment = ''; }
        if (comment_to === void 0) { comment_to = ''; }
        return this.call('sendfromaddress', [from, to, amount, comment, comment_to]);
    };
    BChain.prototype.sendRawTransaction = function (hexstring) { return this.call('sendrawtransaction', [hexstring]); };
    BChain.prototype.sendToAddress = function (address, amount, comment, comment_to) {
        if (comment === void 0) { comment = ''; }
        if (comment_to === void 0) { comment_to = ''; }
        return this.call('sendtoaddress', [address, amount, comment, comment_to]);
    };
    BChain.prototype.sendwithData = function (address, amount, data) { return this.call('sendwithdata', [address, amount, data]); };
    BChain.prototype.sendwithDataFrom = function (address, amount, data) { return this.call('sendwithdatafrom', [address, amount, data]); };
    BChain.prototype.sendWithMetadata = function (address, amount, data) { return this.call('sendwithmetadata', [address, amount, data]); };
    BChain.prototype.sendWithMetadataFrom = function (from, to, amount, data) { return this.call('sendwithmetadatafrom', [from, to, amount, data]); };
    BChain.prototype.setLastBlock = function (hash) { return this.call('setlastblock', [hash]); };
    BChain.prototype.setRunTimeparam = function (param, value) { return this.call('setruntimeparam', [param, value]); };
    BChain.prototype.signMessage = function (address, message) { return this.call('signmessage', [address, message]); };
    BChain.prototype.signRawTransaction = function (hexstring, parents, privatekeys, sighashtype) {
        if (parents === void 0) { parents = {}; }
        if (privatekeys === void 0) { privatekeys = {}; }
        if (sighashtype === void 0) { sighashtype = {}; }
        return this.call('signrawtransaction', [hexstring, parents, privatekeys, sighashtype]);
    };
    BChain.prototype.stop = function () { return this.call('stop', []); };
    BChain.prototype.subscribe = function (stream, rescan) {
        if (rescan === void 0) { rescan = true; }
        return this.call('subscribe', [stream, rescan]);
    };
    BChain.prototype.unsubscribe = function (stream) { return this.call('unsubscribe', [stream]); };
    BChain.prototype.validateAddress = function (address) { return this.call('validateaddress', [address]); };
    BChain.prototype.verifyMessage = function (address, signature, message) { return this.call('verifymessage', [address, signature, message]); };
    BChain.prototype.walletLock = function () { return this.call('walletlock', []); };
    BChain.prototype.walletPassphrase = function (passphrase, timeout) { return this.call('walletpassphrase', [passphrase, timeout]); };
    BChain.prototype.walletPassphraseChange = function (old_passphrase, new_passphrase) { return this.call('walletpassphrasechange', [old_passphrase, new_passphrase]); };
    return BChain;
}());
exports["default"] = BChain;
