"use strict";
exports.__esModule = true;
var bchain_1 = require("./lib/bchain");
var R = require("ramda");
var bchain = new bchain_1["default"]({ username: 'multichainrpc', password: '6FvcobcXbS2UPXEmkVBof32B15fNMR9UPhVtUzvq6CCP' });
var MyObserver = /** @class */ (function () {
    function MyObserver(name) {
        this.name = name;
    }
    MyObserver.prototype.complete = function () {
        console.log("[" + this.name + "] Completed");
    };
    MyObserver.prototype.error = function (err) {
        console.log("[" + this.name + "] Error: " + err);
    };
    MyObserver.prototype.next = function (value) {
        console.log("[" + this.name + "] Next: ", value);
    };
    return MyObserver;
}());
// let test = observer => observer.subscribe(new MyObserver('test'));
function runBasicTests() {
    bchain.getInfo().subscribe(new MyObserver('getInfo'));
    // bchain.searchRawTransactions('1Ur2ph9i9uSHM2c5WKHctB15qDrSPQ5bu9gM4c').subscribe(new MyObserver('getInfo'));
}
function runRxjsTests() {
    var getAssets = R.map(function (x) { return x.vout[0].assets; });
    bchain.searchRawTransactions('1Ur2ph9i9uSHM2c5WKHctB15qDrSPQ5bu9gM4c')
        .map(function (x) { return x.result; })
        .map(getAssets)
        .subscribe(new MyObserver('searchRawTransactions'));
}
function runUnimplementedTests() {
    // examples for unimplemented calls
    bchain.getRuntimeParams().subscribe(new MyObserver('getRuntimeParams'));
    bchain.call('searchrawtransactions', ['1Ur2ph9i9uSHM2c5WKHctB15qDrSPQ5bu9gM4c']).subscribe(new MyObserver('searchrawtransactions'));
}
runRxjsTests();
bchain.undefinedFunctions.forEach(function (x) { return console.log('\t' + x); });
